tarball=none

ALLTESTS="
admin_tools         fs_perms_simple       ltp-aiodio.part3  net_stress.appl                   quickhit
can                 fs_readonly           ltp-aiodio.part4  net_stress.broken_ip              rpc_tests
cap_bounds          fsx                   ltplite           net_stress.interfaces             sched
commands            hugetlb               lvm.part1         net_stress.ipsec_icmp             scsi_debug.part1
connectors          hyperthreading        lvm.part2         net_stress.ipsec_tcp              securebits
containers          ima                   math              net_stress.ipsec_udp              smack
controllers         input                 mm                net_stress.multicast              stress.part1
cpuhotplug          io                    modules           net_stress.route                  stress.part2
crashme             io_cd                 net.features      network_commands                  stress.part3
dio                 io_floppy             net.ipv6          nptl                              syscalls
dma_thread_diotest  ipc                   net.ipv6_lib      numa                              syscalls-ipc
fcntl-locktests     kernel_misc           net.multicast     nw_under_ns                       timers
filecaps            ltp-aio-stress.part1  net.nfs           pipes                             tirpc_tests
fs                  ltp-aio-stress.part2  net.rpc           power_management_tests            tpm_tools
fs_bind             ltp-aiodio.part1      net.sctp          power_management_tests_exclusive  tracing
fs_ext4             ltp-aiodio.part2      net.tcp_cmds      pty"

ALLPTSTESTS="AIO MEM MSG SEM SIG THR TMR TPS"

ALLRTTESTS="
perf/latency
func/measurement
func/hrtimer-prio
func/gtod_latency
func/periodic_cpu_load
func/pthread_kill_latency
func/sched_football
func/pi-tests
func/thread_clock
func/rt-migrate
func/matrix_mult
func/prio-preempt
func/prio-wake
func/pi_perf
func/sched_latency
func/async_handler
func/sched_jitter
"

function test_pre_check {
    assert_define SDKROOT
    assert_define CC
    assert_define AR
    assert_define RANLIB
    assert_define LDFLAGS
    assert_define FUNCTIONAL_LTP_TESTS
    is_on_target opt_ltp_target_run.sh LTP_TARGET_RUN_PROGRAM /opt/fuego.LTP
}

function test_build {
    touch test_suite_ready
}

function test_deploy {
    return 0
}

function test_run {
    echo "Running LTP"

    TESTS=""
    PTSTESTS=""
    RTTESTS=""

    for a in $FUNCTIONAL_LTP_TESTS; do
        for b in $ALLTESTS; do
            if [ "$a" == "$b" ]; then
                TESTS+="$a "
            fi
        done

        for b in $ALLPTSTESTS; do
            if [ "$a" == "$b" ]; then
                PTSTESTS+="$a "
            fi
        done

        for b in $ALLRTTESTS; do
            if [ "$a" == "$b" ]; then
                RTTESTS+="$a "
            fi
        done
    done

    # Let some of the tests fail, the information will be in the result xlsx file
    cmd "cp /opt/fuego.LTP/opt_ltp_target_run.sh $BUILD_TESTDIR/fuego.$TESTDIR"

    set +e
    report "cd $BOARD_TESTDIR/fuego.$TESTDIR; TESTS=\"$TESTS\"; PTSTESTS=\"$PTSTESTS\"; RTTESTS=\"$RTTESTS\"; . ./opt_ltp_target_run.sh"
    set -e
}

function test_processing {
    echo "Processing LTP"

    get $BOARD_TESTDIR/fuego.$TESTDIR/result .
    cd result/
    # Restore the path so that python works properly
    export PATH=$ORIG_PATH
    cp $TEST_HOME/ltp_process.py .
    python ltp_process.py
    [ -e results.xlsx ] && cp results.xlsx ${LOGDIR}/results.xlsx
    [ -e rt.log ] && cp rt.log $FUEGO_RW/logs/$JOB_NAME/
    cd ..
    rm -rf result/
}

. $FUEGO_CORE/engine/scripts/functional.sh
